<template>
  <form @submit.prevent="addPerson">
    <label>
      <span>Vorname ({{firstName}})</span>
      <input type="text" name="firstName" placeholder="Max" v-model.trim="firstName" required>
      <!--<input type="text" name="firstName" placeholder="Max" @input="event => firstName = event.target.value" :value="firstName" required>-->
    </label>
    <label>
      <span>Nachname ({{lastName}})</span>
      <input type="text" name="lastName" placeholder="Muster" v-model.trim="lastName" required>
    </label>
    <button type="submit" class="btn btn-primary">Speichern</button>
  </form>

  <!--<CustomDialog :model-value="isDialogOpen" @update:model-value="(event) => isDialogOpen=event"/>-->
  <CustomDialog v-model="isDialogOpen"/>
  <button @click="isDialogOpen = true">Show Dialog</button>

  <ul>
    <!--<li v-for="(person, index) in persons">
      {{person.firstName}} {{person.lastName}}
      <button @click="deletePerson(index)">Löschen</button>
    </li>-->
    <PersonEntry v-for="(currentPerson, index) in personsStore.persons" :index="index" :person="currentPerson" @update="updatePerson" />
  </ul>
</template>

<script setup>
import {ref} from "vue";
import PersonEntry from "@/components/PersonEntry.vue";
import CustomDialog from "@/components/CustomDialog.vue";
import {usePersonsStore} from "@/stores/PersonStore"; // <- Funktion zum Aufrufen des Stores wird importiert

const personsStore = usePersonsStore() // <- Store wird eingebunden
const isDialogOpen = ref(false)

const firstName = ref('')
const lastName = ref('')

function addPerson(event) {
  console.log(event)

  personsStore.persons.push({
    firstName: firstName.value,
    lastName: lastName.value
  })

  firstName.value = ''
  lastName.value = ''
}

function closeDialog() {
  isDialogOpen.value = false
}

function updatePerson(updatedPerson, originalPerson) {
  console.log(updatedPerson, originalPerson)
  console.log("update person")
  const personIndex = personsStore.persons.indexOf(originalPerson)
  console.log(personIndex)
  if(personIndex >= 0) {
    personsStore.persons.splice(personIndex, 1, updatedPerson)
    // persons.value.splice(personIndex, 1, updatedPerson)
  }
}

function deletePerson(index) {
  personsStore.persons.splice(index, 1)
}
</script>
